package cc.smtweb.system.bpm.web.design.preview;

import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.exception.BizException;
import cc.smtweb.framework.core.exception.SwException;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.framework.core.util.CommUtil;
import cc.smtweb.system.bpm.util.TreeDataUtil;
import cc.smtweb.system.bpm.web.design.db.ModelProjectCache;
import cc.smtweb.system.bpm.web.design.form.ModelForm;
import cc.smtweb.system.bpm.web.design.form.ModelFormCache;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

@SwService
public class PreviewMenuTreeService {
  @SwParam
  private DbEngine dbEngine;

  public R treeAll(@SwParam("module") String module, UserSession us) {
    String prj_id = ModelProjectCache.getInstance().getIdByModule(module);
    List<ModelForm> listForm;
    if (StringUtils.isNotEmpty(prj_id)) {
      listForm = new ArrayList<>(ModelFormCache.getInstance().getFormsByPrj(Long.parseLong(prj_id)));
    } else {
      listForm = new ArrayList<>(ModelFormCache.getInstance().getAll());
    }
    listForm.sort((o1, o2) -> CommUtil.chineseCompare(o1.getTitle(), o2.getTitle()));
    if (listForm.isEmpty()) throw new BizException("此项目无页面设计！");

    List<MenuVO> list = new ArrayList<>(listForm.size());
    for (ModelForm form: listForm) {
      MenuVO menu = new MenuVO();
      menu.setId(form.getId());
      menu.setName(form.getTitle());
      menu.setPath("/bpm/" + form.getId());
//      menu.setParentId(-1L);
      list.add(menu);
    }

    MenuVO root = new MenuVO();
    root.setName("项目");
    root.setPath(module);
    List<MenuVO> data = TreeDataUtil.buildTree(root, list, MenuVO.createTreeHandler());

    return R.success(data);
  }
}
